using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ZylGPSReceiver;

namespace CSharpDemo
{	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Button btnClose;	
		private System.Windows.Forms.ListBox lstPorts;

		private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox textBoxSatCount;
		private System.Windows.Forms.TextBox textBoxHeading;
		private System.Windows.Forms.TextBox textBoxSpeed;
		private System.Windows.Forms.TextBox textBoxAlt;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBoxLongDir;
		private System.Windows.Forms.TextBox textBoxLongSec;
		private System.Windows.Forms.TextBox textBoxLongMin;
		private System.Windows.Forms.TextBox textBoxLongDeg;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxLatDir;
		private System.Windows.Forms.TextBox textBoxLatSec;
		private System.Windows.Forms.TextBox textBoxLatMin;
		private System.Windows.Forms.TextBox textBoxLatDeg;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label lblLocalTime;
		private System.Windows.Forms.Label lblUTCTime;
		private ZylGPSReceiver.GPSReceiver gpsReceiver;
		private System.Windows.Forms.PictureBox pBox;
		private System.Windows.Forms.Button btnDetect;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.ListBox lstBaudRate;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.textBoxOut = new System.Windows.Forms.TextBox();
			this.lstPorts = new System.Windows.Forms.ListBox();
			this.btnOpen = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.textBoxSatCount = new System.Windows.Forms.TextBox();
			this.textBoxHeading = new System.Windows.Forms.TextBox();
			this.textBoxSpeed = new System.Windows.Forms.TextBox();
			this.textBoxAlt = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.textBoxLongDir = new System.Windows.Forms.TextBox();
			this.textBoxLongSec = new System.Windows.Forms.TextBox();
			this.textBoxLongMin = new System.Windows.Forms.TextBox();
			this.textBoxLongDeg = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.textBoxLatDir = new System.Windows.Forms.TextBox();
			this.textBoxLatSec = new System.Windows.Forms.TextBox();
			this.textBoxLatMin = new System.Windows.Forms.TextBox();
			this.textBoxLatDeg = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.lblLocalTime = new System.Windows.Forms.Label();
			this.lblUTCTime = new System.Windows.Forms.Label();
			this.gpsReceiver = new ZylGPSReceiver.GPSReceiver(this.components);
			this.pBox = new System.Windows.Forms.PictureBox();
			this.btnDetect = new System.Windows.Forms.Button();
			this.lstBaudRate = new System.Windows.Forms.ListBox();
			this.label15 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxOut
			// 
			this.textBoxOut.Location = new System.Drawing.Point(8, 112);
			this.textBoxOut.Multiline = true;
			this.textBoxOut.Name = "textBoxOut";
			this.textBoxOut.ReadOnly = true;
			this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxOut.Size = new System.Drawing.Size(296, 120);
			this.textBoxOut.TabIndex = 0;
			this.textBoxOut.Text = "";
			// 
			// lstPorts
			// 
			this.lstPorts.Items.AddRange(new object[] {
														  "COM1",
														  "COM2",
														  "COM3",
														  "COM4",
														  "COM5",
														  "COM6",
														  "COM7",
														  "COM8",
														  "COM9",
														  "COM10",
														  "COM11",
														  "COM12",
														  "COM13",
														  "COM14",
														  "COM15",
														  "COM16",
														  "COM17",
														  "COM18",
														  "COM19",
														  "COM20",
														  "COM21",
														  "COM22",
														  "COM23",
														  "COM24",
														  "COM25"});
			this.lstPorts.Location = new System.Drawing.Point(8, 40);
			this.lstPorts.Name = "lstPorts";
			this.lstPorts.Size = new System.Drawing.Size(64, 56);
			this.lstPorts.TabIndex = 1;
			// 
			// btnOpen
			// 
			this.btnOpen.Location = new System.Drawing.Point(176, 48);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.TabIndex = 2;
			this.btnOpen.Text = "Open";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(176, 80);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 3;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label12,
																					this.label11,
																					this.label10,
																					this.label9,
																					this.textBoxSatCount,
																					this.textBoxHeading,
																					this.textBoxSpeed,
																					this.textBoxAlt});
			this.groupBox3.Location = new System.Drawing.Point(8, 400);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(296, 72);
			this.groupBox3.TabIndex = 9;
			this.groupBox3.TabStop = false;
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(224, 24);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(56, 16);
			this.label12.TabIndex = 7;
			this.label12.Text = "Sat Count";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(152, 24);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(56, 16);
			this.label11.TabIndex = 6;
			this.label11.Text = "Heading";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(80, 24);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(48, 16);
			this.label10.TabIndex = 5;
			this.label10.Text = "Speed";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 24);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(56, 16);
			this.label9.TabIndex = 4;
			this.label9.Text = "Altitude";
			// 
			// textBoxSatCount
			// 
			this.textBoxSatCount.Location = new System.Drawing.Point(224, 40);
			this.textBoxSatCount.Name = "textBoxSatCount";
			this.textBoxSatCount.ReadOnly = true;
			this.textBoxSatCount.Size = new System.Drawing.Size(64, 20);
			this.textBoxSatCount.TabIndex = 3;
			this.textBoxSatCount.Text = "";
			// 
			// textBoxHeading
			// 
			this.textBoxHeading.Location = new System.Drawing.Point(152, 40);
			this.textBoxHeading.Name = "textBoxHeading";
			this.textBoxHeading.ReadOnly = true;
			this.textBoxHeading.Size = new System.Drawing.Size(64, 20);
			this.textBoxHeading.TabIndex = 2;
			this.textBoxHeading.Text = "";
			// 
			// textBoxSpeed
			// 
			this.textBoxSpeed.Location = new System.Drawing.Point(80, 40);
			this.textBoxSpeed.Name = "textBoxSpeed";
			this.textBoxSpeed.ReadOnly = true;
			this.textBoxSpeed.Size = new System.Drawing.Size(64, 20);
			this.textBoxSpeed.TabIndex = 1;
			this.textBoxSpeed.Text = "";
			// 
			// textBoxAlt
			// 
			this.textBoxAlt.Location = new System.Drawing.Point(8, 40);
			this.textBoxAlt.Name = "textBoxAlt";
			this.textBoxAlt.ReadOnly = true;
			this.textBoxAlt.Size = new System.Drawing.Size(64, 20);
			this.textBoxAlt.TabIndex = 0;
			this.textBoxAlt.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label8,
																					this.label7,
																					this.label6,
																					this.label5,
																					this.textBoxLongDir,
																					this.textBoxLongSec,
																					this.textBoxLongMin,
																					this.textBoxLongDeg});
			this.groupBox2.Location = new System.Drawing.Point(8, 320);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(296, 72);
			this.groupBox2.TabIndex = 8;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Longitude";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(224, 24);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(56, 16);
			this.label8.TabIndex = 7;
			this.label8.Text = "Direction";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(152, 24);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(56, 16);
			this.label7.TabIndex = 6;
			this.label7.Text = "Second";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(80, 24);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 16);
			this.label6.TabIndex = 5;
			this.label6.Text = "Minute";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 24);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 4;
			this.label5.Text = "Degree";
			// 
			// textBoxLongDir
			// 
			this.textBoxLongDir.Location = new System.Drawing.Point(224, 40);
			this.textBoxLongDir.Name = "textBoxLongDir";
			this.textBoxLongDir.ReadOnly = true;
			this.textBoxLongDir.Size = new System.Drawing.Size(64, 20);
			this.textBoxLongDir.TabIndex = 3;
			this.textBoxLongDir.Text = "";
			// 
			// textBoxLongSec
			// 
			this.textBoxLongSec.Location = new System.Drawing.Point(152, 40);
			this.textBoxLongSec.Name = "textBoxLongSec";
			this.textBoxLongSec.ReadOnly = true;
			this.textBoxLongSec.Size = new System.Drawing.Size(64, 20);
			this.textBoxLongSec.TabIndex = 2;
			this.textBoxLongSec.Text = "";
			// 
			// textBoxLongMin
			// 
			this.textBoxLongMin.Location = new System.Drawing.Point(80, 40);
			this.textBoxLongMin.Name = "textBoxLongMin";
			this.textBoxLongMin.ReadOnly = true;
			this.textBoxLongMin.Size = new System.Drawing.Size(64, 20);
			this.textBoxLongMin.TabIndex = 1;
			this.textBoxLongMin.Text = "";
			// 
			// textBoxLongDeg
			// 
			this.textBoxLongDeg.Location = new System.Drawing.Point(8, 40);
			this.textBoxLongDeg.Name = "textBoxLongDeg";
			this.textBoxLongDeg.ReadOnly = true;
			this.textBoxLongDeg.Size = new System.Drawing.Size(64, 20);
			this.textBoxLongDeg.TabIndex = 0;
			this.textBoxLongDeg.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label4,
																					this.label3,
																					this.label2,
																					this.label1,
																					this.textBoxLatDir,
																					this.textBoxLatSec,
																					this.textBoxLatMin,
																					this.textBoxLatDeg});
			this.groupBox1.Location = new System.Drawing.Point(8, 240);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(296, 72);
			this.groupBox1.TabIndex = 7;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Latitude";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(224, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "Direction";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(152, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "Second";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(80, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Minute";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Degree";
			// 
			// textBoxLatDir
			// 
			this.textBoxLatDir.Location = new System.Drawing.Point(224, 40);
			this.textBoxLatDir.Name = "textBoxLatDir";
			this.textBoxLatDir.ReadOnly = true;
			this.textBoxLatDir.Size = new System.Drawing.Size(64, 20);
			this.textBoxLatDir.TabIndex = 3;
			this.textBoxLatDir.Text = "";
			// 
			// textBoxLatSec
			// 
			this.textBoxLatSec.Location = new System.Drawing.Point(152, 40);
			this.textBoxLatSec.Name = "textBoxLatSec";
			this.textBoxLatSec.ReadOnly = true;
			this.textBoxLatSec.Size = new System.Drawing.Size(64, 20);
			this.textBoxLatSec.TabIndex = 2;
			this.textBoxLatSec.Text = "";
			// 
			// textBoxLatMin
			// 
			this.textBoxLatMin.Location = new System.Drawing.Point(80, 40);
			this.textBoxLatMin.Name = "textBoxLatMin";
			this.textBoxLatMin.ReadOnly = true;
			this.textBoxLatMin.Size = new System.Drawing.Size(64, 20);
			this.textBoxLatMin.TabIndex = 1;
			this.textBoxLatMin.Text = "";
			// 
			// textBoxLatDeg
			// 
			this.textBoxLatDeg.Location = new System.Drawing.Point(8, 40);
			this.textBoxLatDeg.Name = "textBoxLatDeg";
			this.textBoxLatDeg.ReadOnly = true;
			this.textBoxLatDeg.Size = new System.Drawing.Size(64, 20);
			this.textBoxLatDeg.TabIndex = 0;
			this.textBoxLatDeg.Text = "";
			// 
			// label14
			// 
			this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label14.Location = new System.Drawing.Point(312, 448);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(72, 23);
			this.label14.TabIndex = 17;
			this.label14.Text = "Local Time:";
			// 
			// label13
			// 
			this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label13.Location = new System.Drawing.Point(312, 424);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(72, 23);
			this.label13.TabIndex = 16;
			this.label13.Text = "UTC Time:";
			// 
			// lblLocalTime
			// 
			this.lblLocalTime.AutoSize = true;
			this.lblLocalTime.Location = new System.Drawing.Point(400, 448);
			this.lblLocalTime.Name = "lblLocalTime";
			this.lblLocalTime.Size = new System.Drawing.Size(10, 13);
			this.lblLocalTime.TabIndex = 15;
			this.lblLocalTime.Text = "?";
			// 
			// lblUTCTime
			// 
			this.lblUTCTime.AutoSize = true;
			this.lblUTCTime.Location = new System.Drawing.Point(400, 424);
			this.lblUTCTime.Name = "lblUTCTime";
			this.lblUTCTime.Size = new System.Drawing.Size(10, 13);
			this.lblUTCTime.TabIndex = 14;
			this.lblUTCTime.Text = "?";
			// 
			// gpsReceiver
			// 
			this.gpsReceiver.BaudRate = ZylGPSReceiver.SerialBaudRate.br004800;
			this.gpsReceiver.DataWidth = ZylGPSReceiver.SerialDataWidth.dw8Bits;
			this.gpsReceiver.Delay = 100;
			this.gpsReceiver.EnableDTROnOpen = true;
			this.gpsReceiver.EnableRTSOnOpen = true;
			this.gpsReceiver.ForceCheckSum = true;
			this.gpsReceiver.HardwareFlowControl = ZylGPSReceiver.SerialHardwareFlowControl.hfNone;
			this.gpsReceiver.ParityBits = ZylGPSReceiver.SerialParityBits.pbNone;
			this.gpsReceiver.Port = ZylGPSReceiver.SerialCommPort.COM02;
			this.gpsReceiver.Priority = System.Threading.ThreadPriority.Normal;
			this.gpsReceiver.ReadIntervalTimeout = -1;
			this.gpsReceiver.ReadTotalTimeoutConstant = 0;
			this.gpsReceiver.ReadTotalTimeoutMultiplier = 0;
			this.gpsReceiver.SoftwareFlowControl = ZylGPSReceiver.SerialSoftwareFlowControl.sfNone;
			this.gpsReceiver.StopBits = ZylGPSReceiver.SerialStopBits.sb1Bit;
			this.gpsReceiver.WriteTotalTimeoutConstant = 1000;
			this.gpsReceiver.WriteTotalTimeoutMultiplier = 100;
			this.gpsReceiver.LongitudeChanged += new ZylGPSReceiver.PositionEventHandler(this.gpsReceiver_LongitudeChanged);
			this.gpsReceiver.Sent += new ZylGPSReceiver.DataEventHandler(this.serialPort_Received);
			this.gpsReceiver.HeadingChanged += new ZylGPSReceiver.ParamEventHandler(this.gpsReceiver_HeadingChanged);
			this.gpsReceiver.AltitudeChanged += new ZylGPSReceiver.ParamEventHandler(this.gpsReceiver_AltitudeChanged);
			this.gpsReceiver.Disconnected += new ZylGPSReceiver.ConnectionEventHandler(this.gpsReceiver_Disconnected);
			this.gpsReceiver.SatellitesReceived += new ZylGPSReceiver.SatellitesEventHandler(this.gpsReceiver_SatellitesReceived);
			this.gpsReceiver.Received += new ZylGPSReceiver.DataEventHandler(this.serialPort_Received);
			this.gpsReceiver.LatitudeChanged += new ZylGPSReceiver.PositionEventHandler(this.gpsReceiver_LatitudeChanged);
			this.gpsReceiver.SatelliteReceived += new ZylGPSReceiver.SatelliteEventHandler(this.gpsReceiver_SatelliteReceived);
			this.gpsReceiver.SpeedChanged += new ZylGPSReceiver.ParamEventHandler(this.gpsReceiver_SpeedChanged);
			this.gpsReceiver.Connected += new ZylGPSReceiver.ConnectionEventHandler(this.gpsReceiver_Connected);
			// 
			// pBox
			// 
			this.pBox.Location = new System.Drawing.Point(320, 8);
			this.pBox.Name = "pBox";
			this.pBox.Size = new System.Drawing.Size(300, 300);
			this.pBox.TabIndex = 18;
			this.pBox.TabStop = false;
			this.pBox.Paint += new System.Windows.Forms.PaintEventHandler(this.pBox_Paint);
			// 
			// btnDetect
			// 
			this.btnDetect.Location = new System.Drawing.Point(176, 16);
			this.btnDetect.Name = "btnDetect";
			this.btnDetect.TabIndex = 19;
			this.btnDetect.Text = "Detect";
			this.btnDetect.Click += new System.EventHandler(this.btnDetect_Click);
			// 
			// lstBaudRate
			// 
			this.lstBaudRate.Items.AddRange(new object[] {
															 "110",
															 "300",
															 "600",
															 "1200",
															 "2400",
															 "4800",
															 "9600",
															 "14400",
															 "19200",
															 "38400",
															 "56000",
															 "57600",
															 "115200",
															 "128000",
															 "256000"});
			this.lstBaudRate.Location = new System.Drawing.Point(80, 40);
			this.lstBaudRate.Name = "lstBaudRate";
			this.lstBaudRate.Size = new System.Drawing.Size(64, 56);
			this.lstBaudRate.TabIndex = 20;
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(8, 16);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(56, 16);
			this.label15.TabIndex = 21;
			this.label15.Text = "Port:";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(80, 16);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(64, 16);
			this.label16.TabIndex = 22;
			this.label16.Text = "Baud Rate:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 478);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label16,
																		  this.label15,
																		  this.lstBaudRate,
																		  this.btnDetect,
																		  this.pBox,
																		  this.label14,
																		  this.label13,
																		  this.lblLocalTime,
																		  this.lblUTCTime,
																		  this.groupBox3,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.btnClose,
																		  this.btnOpen,
																		  this.lstPorts,
																		  this.textBoxOut});
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ZylGPSReceiver.NET Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{			
			gpsReceiver.Port = (SerialCommPort)(lstPorts.SelectedIndex + 1); 
			gpsReceiver.BaudRate = (SerialBaudRate)(Convert.ToInt32(lstBaudRate.Items[lstBaudRate.SelectedIndex].ToString()));
			gpsReceiver.Open();
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			gpsReceiver.Close();
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (gpsReceiver != null)
				gpsReceiver.Close();
		}

		private void serialPort_Received(object sender, ZylGPSReceiver.DataEventArgs e)
		{
			textBoxOut.Text += GPSReceiver.ASCIIByteArrayToString(e.Buffer) + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();

			lblUTCTime.Text = gpsReceiver.Position.GetUTCDateTime().ToString();
			lblLocalTime.Text = gpsReceiver.Position.GetLocalDateTime().ToString();

			textBoxLatDeg.Text = gpsReceiver.Position.Latitude_Degree.ToString();
			textBoxLatMin.Text = gpsReceiver.Position.Latitude_Minute.ToString();
			textBoxLatSec.Text = gpsReceiver.Position.Latitude_Second.ToString();
			if (gpsReceiver.Position.Latitude_Direction == GPSPosition.CardinalPoint.cpNorth)
				textBoxLatDir.Text = "North";
			else
				textBoxLatDir.Text = "South";

			textBoxLongDeg.Text = gpsReceiver.Position.Longitude_Degree.ToString();
			textBoxLongMin.Text = gpsReceiver.Position.Longitude_Minute.ToString();
			textBoxLongSec.Text = gpsReceiver.Position.Longitude_Second.ToString();
			if (gpsReceiver.Position.Longitude_Direction == GPSPosition.CardinalPoint.cpEast)
				textBoxLongDir.Text = "East";
			else
				textBoxLongDir.Text = "West";

			textBoxAlt.Text = gpsReceiver.Position.Altitude.ToString();
			textBoxSpeed.Text = gpsReceiver.Position.Speed_KMH.ToString();
			textBoxHeading.Text = gpsReceiver.Position.Heading.ToString();
			textBoxSatCount.Text = gpsReceiver.Position.Satellite_Count.ToString();
        }

		private void gpsReceiver_SatelliteReceived(object sender, ZylGPSReceiver.SatelliteEventArgs e)
		{
			textBoxOut.Text += "Satellite received: " + e.PseudoRandomCode + "/" + e.Azimuth + "/" + 
				e.Elevation + "/" + e.SignalToNoiseRatio + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();
		}

		private void gpsReceiver_LatitudeChanged(object sender, ZylGPSReceiver.PositionEventArgs e)
		{
			textBoxOut.Text += "Latitude changed: " + 
				GPSPosition.DMSToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();		
		}

		private void gpsReceiver_LongitudeChanged(object sender, ZylGPSReceiver.PositionEventArgs e)
		{
			textBoxOut.Text += "Longitude changed: " + 
				GPSPosition.DMSToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();			
		}

		private void gpsReceiver_AltitudeChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			textBoxOut.Text += "Altitude changed: " + e.Value.ToString() + " m" + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();	
		}

		private void gpsReceiver_Connected(object sender, ZylGPSReceiver.ConnectionEventArgs e)
		{
			textBoxOut.Text += "Connected to: " + e.Port.ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();	
		}

		private void gpsReceiver_Disconnected(object sender, ZylGPSReceiver.ConnectionEventArgs e)
		{
			textBoxOut.Text += "Disconnected from: " + e.Port.ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();	
		}

		private void gpsReceiver_HeadingChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			textBoxOut.Text += "Heading changed: " + e.Value.ToString() + " degrees" + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();	
		}

		private void gpsReceiver_SpeedChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			textBoxOut.Text += "Speed changed: " + e.Value.ToString() + " km/h" + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();	
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			lstBaudRate.SelectedIndex = 5;
		}

		private void pBox_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			gpsReceiver.DrawSatellites(e.Graphics, pBox.Width/2, Color.Black, Color.White);			
		}

		private void btnDetect_Click(object sender, System.EventArgs e)
		{
			SerialCommPort port;
			SerialBaudRate baudRate;
			if (GPSReceiver.DetectGPS(out port, out baudRate))
			{
				MessageBox.Show("Port: " + GPSReceiver.SerialCommPortToString(port) + ", Baud Rate: " + baudRate.ToString());
				lstPorts.SelectedIndex = lstPorts.Items.IndexOf(GPSReceiver.SerialCommPortToString(port));
				lstBaudRate.SelectedIndex = lstBaudRate.Items.IndexOf(((int)baudRate).ToString());
			}
			else
				MessageBox.Show("No GPS detected.");
		}

		private void gpsReceiver_SatellitesReceived(object sender, System.EventArgs e)
		{
			pBox.Invalidate();
		}
	}
}
